﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Charting;
using Telerik.Windows.Controls;

namespace RadChart_SL_2010_Q2_SP
{
    /// <summary>
    /// Interaction logic for Scrolling.xaml
    /// </summary>
    public partial class Zoom : UserControl
    {
        public Zoom()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(Scrolling_Loaded);
            RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(ZoomScrollSettingsX_PropertyChanged);
            RadChart1.DataBound += new EventHandler<ChartDataBoundEventArgs>(RadChart1_DataBound);
        }

        void RadChart1_DataBound(object sender, ChartDataBoundEventArgs e)
        {
            if (zoomscroll)
            {
                TextBlock1.Text += "Start: " + DateTime.FromOADate(RadChart1.DefaultView.ChartArea.AxisX.ActualMinValue).ToShortDateString() + Environment.NewLine;
                TextBlock1.Text += "End: " + DateTime.FromOADate(RadChart1.DefaultView.ChartArea.AxisX.ActualMaxValue).ToShortDateString() + Environment.NewLine;
            }

            zoomscroll = false;

        }

        bool zoomscroll = false;

        void ZoomScrollSettingsX_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {

            if (e.PropertyName == "RangeStart" || e.PropertyName == "RangeEnd")
                zoomscroll = true;
        }

        void Scrolling_Loaded(object sender, RoutedEventArgs e)
        {
            this.SetMappings(RadChart1);
            RadChart1.DefaultView.ChartArea.ZoomScrollSettingsX.ScrollMode = ScrollMode.ScrollAndZoom;
            RadChart1.ItemsSource = new List<MyDateObject>() {
                new MyDateObject(new DateTime(2010, 1, 1), 5),
                new MyDateObject(new DateTime(2010, 2, 1), 6),
                new MyDateObject(new DateTime(2010, 3, 1), 7),
                new MyDateObject(new DateTime(2010, 4, 1), 8),
                new MyDateObject(new DateTime(2010, 5, 1), 9),
                new MyDateObject(new DateTime(2010, 6, 1), 10),
                new MyDateObject(new DateTime(2010, 7, 1), 15),
                new MyDateObject(new DateTime(2010, 8, 1), 16),
                new MyDateObject(new DateTime(2010, 9, 1), 17),
                new MyDateObject(new DateTime(2010, 10, 1), 15),
                new MyDateObject(new DateTime(2010, 11, 1), 15),
                new MyDateObject(new DateTime(2010, 12, 1), 15)
            };
        }


        private void SetMappings(RadChart chart)
        {
            SeriesMapping seriesMapping = new SeriesMapping();
            seriesMapping.SeriesDefinition = new LineSeriesDefinition() ;
            ItemMapping itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.YValue;
            itemMapping.FieldName = "Value";
            seriesMapping.ItemMappings.Add(itemMapping);
            itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.XValue;
            itemMapping.FieldName = "Date";
            seriesMapping.ItemMappings.Add(itemMapping);
            chart.SeriesMappings.Add(seriesMapping);
        }


    }


    public class MyDateObject 
    {
        public double Value { get; set; }
        public DateTime Date { get; set; }

        public MyDateObject(DateTime date, double value)
        {
            this.Date = date;
            this.Value = value;
        }
    }

}
